//
//  AppDelegate.m
//  HA7 logger mini05
//
//  Created by 富樫 豊彦 on 2015/03/08.
//  Copyright (c) 2015年 富樫 豊彦. All rights reserved.
//

#import "AppDelegate.h"

@interface AppDelegate ()
@property (nonatomic)   BOOL    displayOn;
@end


@implementation AppDelegate

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    // Override point for customization after application launch.
    NSLog(@"application didFinishLaunchingWithOptions: load prm");
    
    self.obd = [[ObdDataLogger alloc] init];
    self.obd.dist_s     = [[NSUserDefaults standardUserDefaults] doubleForKey:@"dist_s"];
    self.obd.fuse_s     = [[NSUserDefaults standardUserDefaults] doubleForKey:@"fuse_s"];
    self.obd.runtm      = (long)([[NSUserDefaults standardUserDefaults] doubleForKey:@"runtm"] * 3600.0);
    self.obd.movtm      = (long)([[NSUserDefaults standardUserDefaults] doubleForKey:@"movtm"] * 3600.0);
    self.obd.remainFuel = [[NSUserDefaults standardUserDefaults] doubleForKey:@"remainFuel"];

    // Sweep of temporary files
    NSString *tmpDir = NSTemporaryDirectory();
    NSDirectoryEnumerator *directoryEnumerator = [[NSFileManager defaultManager] enumeratorAtPath:tmpDir];
    for (NSString *file in directoryEnumerator) {
        NSString *path = [tmpDir stringByAppendingString:file];
        [[NSFileManager defaultManager] removeItemAtPath:path error:nil];
        NSLog(@"Sweep=%@",path);
    }
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
    NSLog(@"applicationWillResignActive: save prm");
    
    NSUserDefaults* defaults = [NSUserDefaults standardUserDefaults];
    [defaults setDouble:self.obd.dist_s       forKey:@"dist_s"];
    [defaults setDouble:self.obd.fuse_s       forKey:@"fuse_s"];
    [defaults setDouble:self.obd.runtm/3600.0 forKey:@"runtm"];
    [defaults setDouble:self.obd.movtm/3600.0 forKey:@"movtm"];
    [defaults setDouble:self.obd.remainFuel   forKey:@"remainFuel"];
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
    NSLog(@"applicationDidEnterBackground: sleep ok");
    [UIApplication sharedApplication].idleTimerDisabled = NO;
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
    NSLog(@"applicationWillEnterForeground");
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
    NSLog(@"applicationDidBecomeActive: disp=%d", self.displayOn);
    [UIApplication sharedApplication].idleTimerDisabled = self.displayOn;
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
    NSLog(@"applicationWillTerminate");
}

- (void)setDisplayOn
{
    self.displayOn = YES;
    [UIApplication sharedApplication].idleTimerDisabled = self.displayOn;
}

- (void)unsetDisplayOn
{
    self.displayOn = NO;
    [UIApplication sharedApplication].idleTimerDisabled = self.displayOn;
}

@end
