//
//  VehicleViewController.m
//  HA7 logger mini05
//
//  Created by 富樫 豊彦 on 2015/03/08.
//  Copyright (c) 2015年 富樫 豊彦. All rights reserved.
//

#import "VehicleViewController.h"
#import "AppDelegate.h"

@interface VehicleViewController ()

@property (strong, nonatomic) NSTimer           *updateTimer;
@property (weak, nonatomic)   ObdDataLogger     *obd;

@end


@implementation VehicleViewController

#pragma mark - View Lifecycle

- (void)viewDidLoad {
    [super viewDidLoad];
    AppDelegate *appDeligate = [[UIApplication sharedApplication] delegate];
    self.obd = appDeligate.obd;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    self.updateTimer = [NSTimer scheduledTimerWithTimeInterval:1.0 target:self selector:@selector(refreshView:) userInfo:nil repeats:YES];
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    [self.updateTimer invalidate];
}

- (IBAction)refreshView:(id)sender
{
    [self.ect        setText:[[NSString alloc] initWithFormat:@"%d",self.obd.ect]];
    [self.shrtft1    setText:[[NSString alloc] initWithFormat:@"%d",self.obd.shrtft1]];
    [self.longft1    setText:[[NSString alloc] initWithFormat:@"%d",self.obd.longft1]];
    [self.map        setText:[[NSString alloc] initWithFormat:@"%d",self.obd.map]];
    [self.rpm        setText:[[NSString alloc] initWithFormat:@"%d",self.obd.rpm]];
    [self.vss        setText:[[NSString alloc] initWithFormat:@"%d",self.obd.vss]];
    [self.sparkadv   setText:[[NSString alloc] initWithFormat:@"%d",self.obd.sparkadv]];
    [self.iat        setText:[[NSString alloc] initWithFormat:@"%d",self.obd.iat]];
    [self.tp         setText:[[NSString alloc] initWithFormat:@"%d",self.obd.tp]];
    [self.o2s11      setText:[[NSString alloc] initWithFormat:@"%d",self.obd.o2s11]];
    [self.shrtft11   setText:[[NSString alloc] initWithFormat:@"%d",self.obd.shrtft11]];
    [self.vpwr       setText:[[NSString alloc] initWithFormat:@"%.2f",self.obd.vpwr/1000.0]];
    [self.af         setText:[[NSString alloc] initWithFormat:@"%.2f",self.obd.af]];           // ADD 2013.08.19
    [self.ff         setText:[[NSString alloc] initWithFormat:@"%.2f",self.obd.ff]];           // ADD 2013.08.19
    [self.r          setText:[[NSString alloc] initWithFormat:@"%.2f",self.obd.r]];            // ADD 2013.08.19
    [self.v          setText:[[NSString alloc] initWithFormat:@"%.2f",self.obd.v]];            // ADD 2013.08.19
    [self.atm        setText:[[NSString alloc] initWithFormat:@"%.2f",self.obd.atm]];          // ADD 2013.08.19
    [self.dist       setText:[[NSString alloc] initWithFormat:@"%.2f",self.obd.dist]];         // ADD 2013.08.19
    [self.fuse       setText:[[NSString alloc] initWithFormat:@"%.2f",self.obd.fuse]];         // ADD 2013.08.19
    [self.eff        setText:[[NSString alloc] initWithFormat:@"%.2f",self.obd.eff]];          // ADD 2013.08.19
    [self.dist_s     setText:[[NSString alloc] initWithFormat:@"%.1f",self.obd.dist_s]];
    [self.fuse_s     setText:[[NSString alloc] initWithFormat:@"%.1f",self.obd.fuse_s]];
    [self.runtm      setText:[[NSString alloc] initWithFormat:@"%.1f",self.obd.runtm/3600.0]];
    [self.movtm      setText:[[NSString alloc] initWithFormat:@"%.1f",self.obd.movtm/3600.0]];
    [self.dist_d     setText:[[NSString alloc] initWithFormat:@"%.2f",self.obd.dist_d]];
    [self.fuse_d     setText:[[NSString alloc] initWithFormat:@"%.2f",self.obd.fuse_d]];
    [self.runtm_d    setText:[[NSString alloc] initWithFormat:@"%d:%02d:%02d",(int)self.obd.runtm_d/3600,(int)(self.obd.runtm_d/60)%60,(int)self.obd.runtm_d%60]];
    [self.movtm_d    setText:[[NSString alloc] initWithFormat:@"%d:%02d:%02d",(int)self.obd.movtm_d/3600,(int)(self.obd.movtm_d/60)%60,(int)self.obd.movtm_d%60]];
    [self.remainFuel setText:[[NSString alloc] initWithFormat:@"%.2f",self.obd.remainFuel]]; // ADD 2013.08.19
    [self.latitude   setText:[[NSString alloc] initWithFormat:@"%+.6f",self.obd.latitude]];
    [self.longitude  setText:[[NSString alloc] initWithFormat:@"%+.6f",self.obd.longitude]];
    [self.altitude   setText:[[NSString alloc] initWithFormat:@"%d",self.obd.altitude]];
    [self.heading    setText:[[NSString alloc] initWithFormat:@"%d",self.obd.heading]];
    if (self.obd.valid) {
        if (self.obd.valid_l) {
            if (self.obd.valid_h) {
                self.statusMsg.text = @"Active, all online";
            } else {
                self.statusMsg.text = @"Active, no magnetometer";
            }
        } else {
            if (self.obd.valid_h) {
                self.statusMsg.text = @"Active, no GPS";
            } else {
                self.statusMsg.text = @"Active, no GPS,magnetometer";
            }
        }
    } else {
        self.statusMsg.text = @"Offline";
    }
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
